unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics,
  Controls, Forms, Dialogs, Vcl.StdCtrls,
  Winapi.ShellApi, System.IOUtils, System.Types;

type
  // tH_T̃IvV
  TListDirOption = (ldNone, ldSubSearch, ldOmitFolder, ldBoth);
type
  TForm1 = class(TForm)
    Memo1: TMemo;
    bbtnOpen: TButton;
    bbtnBackup: TButton;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure bbtnOpenClick(Sender: TObject);
    procedure bbtnBackupClick(Sender: TObject);
  private
    { Private 錾 }
    sDoc: String;
    function DoHistorier: Boolean;

  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{*******************************************************************************
 ړI: ʐ
 :
 ߒl:
*******************************************************************************}
procedure TForm1.FormCreate(Sender: TObject);
const
  cPath_List = 'Historier_List.txt';
begin

  // ΏۃtH_pXꗗ̓ǍiEXEƓKw̑ΏۃeLXgj
  if (FileExists(ExtractFilePath(Application.Exename) + cPath_List)) then
  begin
    try
      Memo1.Lines.LoadFromFile(ExtractFilePath(Application.Exename) + cPath_List);
    except // O𖳎
    end;
  end;

  // obNAbṽtH_w
  //isDoc̓O[oStringϐj
  //i{TvłEXEƓKwɁuB17vtH_zj
  sDoc := ExtractFilePath(Application.Exename) + 'B17\';
  if not(DirectoryExists(sDoc)) then
  begin
    ForceDirectories(sDoc); // tH_ƕۑG[ɂȂ̂ŐĂ
  end;

  // ̎stŋNꍇ̓TCgŎobNAbv
  if (ParamStr(1) = 'SILENT') then
  begin
    try
      DoHistorier;  // DoHistorier֐ɂĂ͌q
    finally
      // ʂ
      //iFormCreateFormShoẘԂCloseȂ߁Aŕj
      PostMessage(Handle, WM_Close, 0, 0);
    end;
  end;
end;

{*******************************************************************************
 ړI: ۑJ{^ 
 :
 ߒl:
*******************************************************************************}
procedure TForm1.bbtnOpenClick(Sender: TObject);
begin
  // obNAbṽtH_J
  ShellExecute(Application.Handle,'OPEN',PChar(sDoc),'','',SW_SHOW);
end;

{*******************************************************************************
 ړI: obNAbvs{^ 
 :
 ߒl:
*******************************************************************************}
procedure TForm1.bbtnBackupClick(Sender: TObject);
begin
  if DoHistorier then  // DoHistorier֐ɂĂ͌q
  begin
    Application.MessageBox('܂B', 'obNAbv', MB_ICONASTERISK);
  end;
end;

{*******************************************************************************
 ړI: w肵fBNg̃t@Cꗗ쐬
 : APath - ΏۃfBNg̃pX
       AList - (߂l)ʑpStringList
       Aldo  - IvV(ldNoneȂ ldSubSearchTutH_Q
                          ldOmitFolderTutH_̂̂͏O ldBoth)
 ߒl: 
*******************************************************************************}
function ListDirTree(APath: string; var AList: TStringList; Aldo: TListDirOption = ldNone): Boolean;
var
  LDirList : TStringDynArray;
  LFilesList : TStringDynArray;
  LDirName : String;
  LFileName  : String;
begin

  // AListɂ͒ǋL邽߁AKvȏꍇ͌ďołĂ

  Result := False; // 

  // AList݂Ȃꍇ
  if (not Assigned(AList)) then
  begin
    AList := TStringList.Create;
  end;

  // APath݂ȂꍇI
  if (not DirectoryExists(APath)) then
  begin
    Exit;
  end;

  // APath̃fBNg̃Xg쐬
  LDirList := TDirectory.GetDirectories(APath);
  for LDirName in LDirList do
  begin
    // (w莞̂)TutH_ʂɒǉ
    if (Aldo in [ldNone, ldSubSearch]) then
    begin
      AList.Add((LDirName));
    end;

    // (w莞̂)TutH_ċA
    if (Aldo in [ldSubSearch, ldBoth]) then
    begin
      ListDirTree(LDirName, AList, Aldo);
    end;
  end;

  // APath̃t@C̃Xg쐬
  LFilesList := TDirectory.GetFiles(APath);
  for LFileName in LFilesList do
  begin
    AList.Add((LFileName));
  end;

  AList.Sort; // OɃ\[g
  Result := True;
end;

{*******************************************************************************
 ړI: obNAbvs
 :
 ߒl: 
*******************************************************************************}
function TForm1.DoHistorier: Boolean;
var
  i, j: Integer;
  sPath: String;
  sFold: String;
  sSave: String;
  slFileList: TStringList;
begin

  Result := True;
  slFileList := TStringList.Create;
  try
    for i := 0 to (Memo1.Lines.Count - 1) do
    begin
      sPath := Memo1.Lines[i];
      slFileList.Clear;
      ListDirTree(sPath, slFileList, ldBoth);

      for j := 0 to (slFileList.Count - 1) do
      begin
        // tpXɁu__historyv܂܂ĂA
        // u.~~v́u~vŏIꍇobNAbvt@CƔf
        if (Pos('__history', LowerCase(slFileList[j])) > 0) and
           (Copy(slFileList[j], Length(slFileList[j]), 1) = '~') then
        begin
          // Rs[tH_pX擾(pXɎgȂpu:vu\vSpɕϊ)
          sFold := ExtractFileDir(slFileList[j]);
          sFold := StringReplace(sFold, ':', 'F', [rfReplaceAll]);
          sFold := StringReplace(sFold, '\', '', [rfReplaceAll]);

          // Rs[t@CpX̎w
          sSave := sDoc + sFold + '\' + ExtractFileName(slFileList[j]);

          // Rs[tH_쐬
          if (not(DirectoryExists(ExtractFilePath(sSave)))) then
          begin
            ForceDirectories(ExtractFilePath(sSave));
          end;

          // Rs[siɓ̃t@Cꍇ̓Rs[Ȃj
          if (not(FileExists(sSave))) then
          begin
            Result := Result and
                      CopyFile(PChar(slFileList[j]), PChar(sSave), False);
          end;
        end;
      end;
    end;
  finally
    FreeAndNil(slFileList);
  end;

  if not Result then
  begin
    Application.MessageBox('st@C܂B', 'obNAbv', MB_ICONEXCLAMATION);
  end;
end;

end.

